#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <sys/ioctl.h>

pid_t pty_fork(int *, char *,int, const struct termios *, const struct winsize *);
int sclient(void);
static void rw_socket(void);


int
main()
{
	if (sclient() < 0) {
		printf("error\n");
		return -1;
	}
	return 0;
}

int
sclient(void)
{
	pid_t pid;
	int fd;
	struct termios tty_old, tty_new;

	if (tcgetattr(STDIN_FILENO, &tty_old) < 0)
		return -1;
	tty_new = tty_old;
	tty_new.c_lflag &= ~(ECHO | ICANON);
	tty_new.c_cc[VMIN] = 1;
	tty_new.c_cc[VTIME] = 0;

	if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &tty_new) < 0)
		return -1;

	if ((pid = pty_fork(&fd, NULL, 0, &tty_new, NULL)) < 0) {
		return -1;
	} else if (pid == 0) {
		rw_socket();
		return 0;
	}

#if 1
	int ch;
	read(STDIN_FILENO, &ch, sizeof(ch));
	printf("ch = %c\n", ch);
	write(fd, &ch, sizeof(ch));
	read(fd, &ch, sizeof(ch));
	printf("ch = %c\n", ch);
#endif
	if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &tty_old) < 0)
		return -1;

	close(fd);
	return 0;
}

static void
rw_socket(void)
{
	int i;
	read(STDIN_FILENO, &i, sizeof(i));
	i += 1;
	write(STDOUT_FILENO, &i, sizeof(i));
}
