#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>
#include <pthread.h>
#include <time.h>
#include <stdio.h>
#include <sys/select.h>
#include <termios.h>
#include <string.h>
#include <limits.h>
#include <pwd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "public.h"

/*键常量定义*/
#define KEY_LEFT  68
#define KEY_RIGHT 67
#define KEY_DOWN  66
#define KEY_UP    65
#define KEY_ENTER 13

/*最大高度与宽度*/
#define Y_MAX 20
#define X_MAX 60

/*运行参数串*/
#define OPTION "cs:j:"   /*c建立主机，j加入主机，s设置速度*/

/*出错码*/
#define CLIENT_ERROR_CMD 11
#define CLIENT_ERROR_RUN 12
#define FILE_LOCK_ERROR_LOCK 13
#define FILE_LOCK_ERROR_UNLOCK 14


/*
 *函数声明部份
 */
void snake_init(void);
void snake_data_init(void);
void snake_key(void);
void snake_exit(int);
void snake_over(void);
void snake_start(void);
void snake_child(int);
void snake_save_record(void);
void create_food(void);
void free_queue(void);
void exit_print(char *);
void command_client(const int, int *);
void snake_client(void);
void *snake_alarm(void *);
void *snake_client_gui(void *);
void *server_recv(void *);
void speed_init(const char *);
char getch(void);
int  snake_read_record(void);
int  input_queue(const int *);
int  out_queue(int *);
int  snake_server_data_init(void);
int  child_xy(void);
int  file_lock_init(void);
int  file_lock(void);
int  file_unlock(void);
int  snake_open_record(int);
void snake_server_check(struct control *, int *, int);
void write_err(char *);
int  lockid(const unsigned int);
void snake_client_queue(void);
void client_run(char *);
void client_send_gui(struct control *);




/*
 * socket function
 */
int socket_server(void);
int socket_client(char *);
int socket_send(const void *, const unsigned int);
int socket_receive(void *, const unsigned int);
void socket_close(void);


/*
 * option function
 */
int getoption(int, char **, const char *);
